#define _RETAIL


#include "GMLuaModule.h"
#include "gm_guardian.h"
#include "sigscan.h"

#include "interface.h"
#include "eiface.h"

IVEngineServer	*engine = NULL;

class CTakeDamageInfo;
class touchlink_t;
class groundlink_t;
class notify_system_event_t;
#include "predictioncopy.h"
class ISave;
class IRestore;
#include "variant_t.h"
#include "entitylist.h"
#include "cbase.h"

#include "baseentity.h"
#include "physics_collisionevent.h"
#include "iservernetworkable.h"


#include <cdll_int.h>
#include <windows.h>
#include <detours.h>

#include "tier0/memdbgon.h"

//bool PassServerEntityFilter( const IHandleEntity *pTouch, const IHandleEntity *pPass ) 
//int CCollisionEvent::ShouldCollide( IPhysicsObject *pObj0, IPhysicsObject *pObj1, void *pGameData0, void *pGameData1 )

// bool PassServerEntityFilter( const IHandleEntity *pTouch, const IHandleEntity *pPass ) 
typedef bool (*PassFilter_t)(const IHandleEntity *, const IHandleEntity *);
bool (*PassServerEntityFilter_Orig)( const IHandleEntity *pTouch, const IHandleEntity *pPass );
bool PassServerEntityFilter_New( const IHandleEntity *pTouch, const IHandleEntity *pPass );

#define PASSFILTER "\x57\x8B\x7C\x24\x0C\x85\xFF\x75\x04"
#define FILTERMASK "xxxxxxxxx"
#define FILTERLEN 9

CSigScan PassFilter_Sig;


class CDetour
{
public:
	int ShouldCollide( IPhysicsObject *pObj0, IPhysicsObject *pObj1, void *pGameData0, void *pGameData1 );
	int CollideTrampoline( IPhysicsObject *pObj0, IPhysicsObject *pObj1, void *pGameData0, void *pGameData1 );
};

// int CCollisionEvent::ShouldCollide( IPhysicsObject *pObj0, IPhysicsObject *pObj1, void *pGameData0, void *pGameData1 )
int (CDetour::* pfCollideDetour)( IPhysicsObject *, IPhysicsObject *, void *, void *);
int (CDetour::* pfCollideTrampoline)( IPhysicsObject *, IPhysicsObject *, void *, void *);

DETOUR_TRAMPOLINE_EMPTY(int CDetour::CollideTrampoline( IPhysicsObject *pObj0, IPhysicsObject *pObj1, void *pGameData0, void *pGameData1 ));

#define SHOULDCOLLIDE "\x83\xEC\x14\x55\x56\x8B\x74\x24\x28"
#define COLLIDEMASK "xxxxxxxxx"
#define COLLIDELEN 9

CSigScan ShouldCollide_Sig;

ILuaInterface *gLua = NULL;

inline CBaseEntity *EntityFromEntityHandle2( const IHandleEntity *pConstHandleEntity )
{
	if(!pConstHandleEntity)
		return NULL;
	IHandleEntity *pHandleEntity = const_cast<IHandleEntity*>(pConstHandleEntity);
	IServerUnknown *pUnk = (IServerUnknown*)pHandleEntity;
	return pUnk->GetBaseEntity();
}

bool CallLuaShouldOverride(CBaseEntity *pEntity0, CBaseEntity *pEntity1)
{
	ILuaObject *func = gLua->GetGlobal("ShouldEntitiesCollide");
	gLua->Push(func);

	int index = -1;
	if(pEntity0)
		index = pEntity0->entindex();
	gLua->Push((float)index);

	index = -1;
	if(pEntity1)
		index = pEntity1->entindex();
	gLua->Push((float)index);

	gLua->Call(2, 1);
	ILuaObject *returno = gLua->GetReturn(0);
	bool overrideit = returno->GetBool();
	return overrideit;
}
bool PassServerEntityFilter_New( const IHandleEntity *pTouch, const IHandleEntity *pPass )
{
	CBaseEntity *pEntTouch = EntityFromEntityHandle2( pTouch );
	CBaseEntity *pEntPass = EntityFromEntityHandle2( pPass );

	if(CallLuaShouldOverride(pEntTouch, pEntPass))
		return false;
	return PassServerEntityFilter_Orig(pTouch, pPass);
}

int CDetour::ShouldCollide( IPhysicsObject *pObj0, IPhysicsObject *pObj1, void *pGameData0, void *pGameData1 )
{
	CBaseEntity *pEntity0 = static_cast<CBaseEntity *>(pGameData0);
	CBaseEntity *pEntity1 = static_cast<CBaseEntity *>(pGameData1);

	if(CallLuaShouldOverride(pEntity0, pEntity1))
		return false;
	return CollideTrampoline(pObj0, pObj1, pGameData0, pGameData1);
}

int Start(lua_State *L)
{
	CreateInterfaceFn interfaceFactory = Sys_GetFactory( "engine.dll" );
	CreateInterfaceFn gameServerFactory = Sys_GetFactory( "server.dll" );

	engine = (IVEngineServer*)interfaceFactory(INTERFACEVERSION_VENGINESERVER, NULL);
	IServerGameClients *clients = (IServerGameClients *)gameServerFactory(INTERFACEVERSION_SERVERGAMECLIENTS, NULL);

	CSigScan::sigscan_dllfunc = (CreateInterfaceFn)gameServerFactory(INTERFACEVERSION_PLAYERINFOMANAGER,NULL);
	bool scan = CSigScan::GetDllMemInfo();
	PassFilter_Sig.Init((unsigned char *)PASSFILTER, FILTERMASK, FILTERLEN);
	PassServerEntityFilter_Orig = (PassFilter_t)DetourFunction((PBYTE)PassFilter_Sig.sig_addr, (PBYTE)PassServerEntityFilter_New);

	ShouldCollide_Sig.Init((unsigned char *)SHOULDCOLLIDE, COLLIDEMASK, COLLIDELEN);

	void *pfTarget = ShouldCollide_Sig.sig_addr;
	pfCollideDetour = &CDetour::ShouldCollide;
	pfCollideTrampoline = &CDetour::CollideTrampoline;

	DetourFunctionWithEmptyTrampoline(*(PBYTE*)&pfCollideTrampoline,
	*(PBYTE*)&pfTarget,
	*(PBYTE*)&pfCollideDetour);


	gLua = Lua();

	return 0;
}

int Close(lua_State *L)
{
	DetourRemove((PBYTE)PassServerEntityFilter_Orig, (PBYTE)PassServerEntityFilter_New);
	DetourRemove(*(PBYTE*)&pfCollideTrampoline, *(PBYTE*)&pfCollideDetour);
	return 0;
}